/**
*	lcd.c
*	kbchCoiQO~SsΉC^[tF[X͂Srbgf[^j
*	PORT 1		b0- D4
*			b1- D5
*			b2- D6
*			b3- D7
*			b4- E
*			b5- R/~W
*			b6- RS
*			b7- 
*	Copyright (c)Junnichi Tomaru 2002-2006
*/
#include	"lcd.h"
#include	"r8c1b.h"
#include	"userdef.h"

#define	LCD_CTRL	PD1	/* o͕WX^ */
#define	LCD_DATA	P1	/* f[^WX^ */
#define	WAIT_BUSY()	while(lcdbusy()==0x80);

#define ASSERT_RS( )		{ LCD_DATA |= 0x40; }
#define ASSERT_RW( )		{ LCD_DATA |= 0x20; }
#define ASSERT_E( )		{ LCD_DATA |= 0x10; }

#define NEGATE_RS( )		{ LCD_DATA &= 0xbf; }
#define NEGATE_RW( )		{ LCD_DATA &= 0xdf; }
#define NEGATE_E( )		{ LCD_DATA &= 0xef; }

#define WRITE_MODE( )		{ LCD_CTRL = 0xff; }
#define READ_MODE( )		{ LCD_CTRL = 0xf0; }

extern void	waitms( word wait );


/**
*	Ȃ
*	 in	Ȃ
*	out	Ȃ
*/
static	void nop( void )
{
}


/**
*	P҂
*	1us = (1/20M)*20cycle
*	 in:Ȃ
*	out:Ȃ
*/
void	wait1us( void )
{	/* 14cycle(JSR,RTS) */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 = 20cycle */
}


/**
*	10us҂
*	 in:Ȃ
*	out:Ȃ
*/
void	wait10us( void )
{
	/* 14cycle(JSR,RTS) */
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 = 20cycle */
}


/**
*	f[^Zbg
*	 in	f[^
*	out	Ȃ
*/
void	write_data( unsigned char data )
{
	byte	dat;

	dat = LCD_DATA & 0xf0;
	dat |= data & 0x0f;
	LCD_DATA = dat;
}


/**
*	f[^ǂ
*	 in	Ȃ
*	out	f[^
*/
unsigned char	read_data( void )
{
	return	LCD_DATA;
}


/**
*	kbcɃf[^
*	 in	f[^
*	out	Ȃ
*/
void	lcdwrite( unsigned char data )
{
	WRITE_MODE( );

	NEGATE_RW( );
	write_data( data >> 4 );
	ASSERT_E( );
	nop( );
	NEGATE_E( );
	write_data( data );
	ASSERT_E( );
	nop( );
	NEGATE_E( );
}


/**
*	kbcf[^ǂ
*	 in	Ȃ
*	out	f[^
*/
unsigned char	lcdread( void )
{
	unsigned char	data;

	READ_MODE( );

	ASSERT_RW( );
	nop( );

	ASSERT_E( );
	data = read_data( ) << 4;
	NEGATE_E( );
	nop( );
	ASSERT_E( );
	nop( );
	data |= read_data( ) & 0x0f;
	NEGATE_E( );

	return data;
}


/**
*	CXgNV
*	 in	f[^
*	out	Ȃ
*/
void	lcdwriteir( unsigned char data )
{
	NEGATE_RS( );
	lcdwrite( data );
}


/**
*	CXgNVǂ
*	 in	Ȃ
*	out	f[^
*/
unsigned char	lcdreadir( void )
{
	NEGATE_RS( );
	return	lcdread( );
}


/**
*	f[^WX^
*	 in	f[^
*	out	Ȃ
*/
void	lcdwritedr( unsigned char data )
{
	ASSERT_RS( );
	lcdwrite( data );
}


/**
*	f[^WX^ǂ
*	 in	Ȃ
*	out	f[^
*/
unsigned char	lcdreaddr( void )
{
	ASSERT_RS( );
	return	lcdread( );
}


/**
*	CXgNViSrbgj
*	 in	f[^
*	out	Ȃ
*/
void	lcdwriteir4( unsigned char data )
{
	WRITE_MODE( );

	NEGATE_RS( );
	NEGATE_RW( );
	write_data( data );
	nop( );
	ASSERT_E( );
	nop( );
	NEGATE_E( );
}


/**
*	rW[Ԏ
*	 in	Ȃ
*	out	0x80:rW[ 0:rW[ł͂Ȃ
*/
char	lcdbusy( void )
{
	return	lcdreadir( ) & 0x80;
}


char	lcdx, lcdy;


/**
*	kbc
*	 in	Ȃ
*	out	Ȃ
*/
void	lcdinit( void )
{
	/* V[PX */
	waitms( 20 );			/* Wait 20 ms */
	lcdwriteir4( 0x03 );
	waitms( 4 );
	lcdwriteir4( 0x03 );
	waitms( 1 );
	lcdwriteir4( 0x03 );
	waitms( 1 );
	lcdwriteir4( 0x02 );		/* Data length 4bits */
	waitms( 1 );
	WAIT_BUSY( );
	lcdwriteir( 0x28 );		/* Set function */
	WAIT_BUSY( );
	lcdwriteir( 0x08 );		/* Display off, cursor off, blink off */
	WAIT_BUSY( );
	lcdwriteir( 0x01 );		/* Clear display */
	WAIT_BUSY( );
	lcdwriteir( 0x06 );		/* Entry mode : cursor increment */
	WAIT_BUSY( );
	lcdwriteir( 0x0C );		/* Display on, cursor off, blink off */

	lcdx = lcdy = 0;
}


/**
*	J[\ʒuw
*	 in	x:ʒu
*		y:sʒu
*	out	Ȃ
*/
void	lcdlocate( char x, char y )
{
	char	addr;

	switch ( y ){
		case 0:		addr = 0x00 + x;	break;
		case 1:		addr = 0x40 + x;	break;
		case 2:		addr = 0x14 + x;	break;
		case 3:		addr = 0x54 + x;	break;
		default:
			return;
	}

	lcdx = x;
	lcdy = y;
	WAIT_BUSY( );
	lcdwriteir( 0x80 | addr );		/* Set DD RAM address */
}


/**
*	ʃNA
*	 in	Ȃ
*	out	Ȃ
*/
void	lcdcls( void )
{
	WAIT_BUSY( );
	lcdwriteir( 0x01 );
	lcdx = lcdy = 0;
}


/**
*	J[\\E\
*	 in	0:\ ̑:\
*	out	Ȃ
*/
void	lcddispcursor( char sw )
{
	WAIT_BUSY( );
	lcdwriteir( 0xc | ( sw ? 0x02 : 0 ) );
}


/**
*	obNXy[X
*	 in	Ȃ
*	out	Ȃ
*/
void	lcdbs( void )
{
	if( lcdx == 0 ){
		return;
	}
	lcdx--;
	lcdlocate( lcdx, lcdy );
}


/**
*	ꕶ\
*	 in	f[^
*	out	Ȃ
*/
void	lcdputch( char c )
{
	if( c == '\b' ){
		lcdbs( );
		return;
	}
	WAIT_BUSY( );
	lcdwritedr( c );
	lcdx++;
}


/**
*	wʒuɈꕶ\iLN^R[hwj
*	 in	   x:ʒu
*		   y:sʒu
*		code:f[^
*	out	Ȃ
*/
void	lcdputcode( char x, char y, char code )
{
	lcdlocate( x, y );
	WAIT_BUSY( );
	lcdwritedr( code );
}


/**
*	\
*	 in	f[^
*	out	Ȃ
*/
void	lcdputstr( char *str )
{
	while( *str != '\0' ){
		lcdputch( *( str++ ) );
	}
}


/**
*	ʒuw肵ĕ\
*	 in	  x:ʒu
*		  y:sʒu
*		str:f[^
*	out	Ȃ
*/
void	lcdprint( char x, char y, char *str )
{
	lcdlocate( x, y );
	lcdputstr( str );
}


/**
*	wʒuw萔̕
*	 in	  x:ʒu
*		  y:sʒu
*		cnt::
*/
void	lcdspace( char x, char y, char cnt )
{
	char	i;

	lcdlocate( x, y );
	for( i = 0; i < cnt; i++ ){
		lcdputch( ' ' );
	}
}


/**
*	sNA
*	 in	NAs
*	out	Ȃ
*/
void	lcdlcls( char line )
{
	lcdspace( 0, line, 20 );
}


/* end of lcd.c */
